Ice Reference Documentation
<<< Previous | Properties | Next >>>

# Ice Default and Override Properties

## Ice.Default.Protocol

### Synopsis

    Ice.Default.Protocol=protocol

### Description

Sets the protocol that is being used if an endpoint uses `default` as the protocol specification. The default value is `tcp`.

## Ice.Default.Host

### Synopsis

    Ice.Default.Host=host

### Description

If an endpoint is specified without a host name (i.e., without a `-h `host`` option), the `host` value from this property is used instead. The default value is the IP address of the local host name.

## Ice.Default.Router

### Synopsis

    Ice.Default.Router=router

### Description

Specifies the default router for all proxies. The value is a stringified proxy to the Glacier2 router control interface. The default router can be overridden on a proxy using the `ice_router()` operation. The default value is no router.

## Ice.Default.Locator

### Synopsis

    Ice.Default.Locator=locator

### Description

Specifies a default locator for all proxies and object adapters. The value is a stringified proxy to the IceGrid locator interface. The default locator can be overridden on a proxy using the `ice_locator()` operation. The default value is no locator.

| The default identity of the IceGrid locator object is `IceGrid/Locator` (see IceGrid.InstanceName). It is listening on the IceGrid client endpoints. For example, if `IceGrid.Registry.Client.Endpoints` is set to `tcp -p 12000 -h localhost`, the stringified proxy for the IceGrid locator is `IceGrid/Locator:tcp -p 12000 -h localhost`.

## Ice.Default.CollocationOptmization

### Synopsis

    Ice.Default.CollocationOptmization=num

### Description

Specifies whether proxy invocations use collocation optimization by default. When enabled, proxy invocations on a collocated servant (i.e., a servant whose object adapter was created by the same communicator as the proxy) are made as a direct method call if possible. Collocated invocations are more efficient because they avoid the overhead of marshaling parameters and sending requests over the network.

Collocation optimization is not supported for asynchronous or Dynamice Ice invocations, nor is it supported in Ice for Python.

If not specified, the default value is 1. Set the property to 0 to disable collocation optimization by default.

## Ice.Override.Timeout

### Synopsis

    Ice.Override.Timeout=num

### Description

If set, this property overrides timeout settings in all endpoints. `num` is the timeout value in milliseconds, or -1 for no timeout.

## Ice.Override.ConnectTimeout

### Synopsis

    Ice.Override.ConnectTimeout=num

### Description

This property overrides timeout settings used to establish connections. `num` is the timeout value in milliseconds, or -1 for no timeout. If this property is not set, then `Ice.Override.Timeout` is used.

## Ice.Override.Compress

### Synopsis

    Ice.Override.Compress=num

### Description

If set, this property overrides compression settings in all proxies. If `num` is set to a value larger than zero, compression is enabled. If zero, compression is disabled.

The setting of this property is ignored in the server role.

Note that, if a client sets `Ice.Override.Compress=1` and sends a compressed request to a server that does not support compression, the server will close the connection and the client will receive ConnectionLostException.

If a client does not support compression and `Ice.Override.Compress=1`, the setting is ignored and a warning message is printed on `stderr`.

Regardless of the setting of this property, requests smaller than 100 bytes are never compressed.

<<< Previous | Home | Next >>>
Ice Thread Pool Properties | Up | Ice Miscellaneous Properties